package com.parivedasolutions.zaastra.gwt.client;

import net.customware.gwt.presenter.client.widget.WidgetDisplay;

import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.StackLayoutPanel;
import com.google.gwt.user.client.ui.Widget;

public class AppView extends Composite implements AppPresenter.Display {

	private FlowPanel panel = new FlowPanel();
	StackLayoutPanel stackPanel = new StackLayoutPanel(Unit.EM);

	private Label rpcExampleHeader = new Label("RPC Example");
	private Label i18nExampleHeader = new Label("I18n Example");
	private Label widgetExampleHeader = new Label("Widget Example");

	public AppView() {
		Label header = new Label("GWT Demo");
		header.addStyleName("main-header");
		panel.add(header);
		int height = Window.getClientHeight() - 30;
		stackPanel.setHeight(height + "px");
		stackPanel.setAnimationDuration(250);

		panel.add(stackPanel);
		initWidget(panel);
	}

	/**
	 * Returns this widget as the {@link WidgetDisplay#asWidget()} value.
	 */
	@Override
	public AppView asWidget() {
		return this;
	}

	public void addI18nExampleWidget(Widget widget) {
		stackPanel.add(widget, i18nExampleHeader, 4);
	}

	public void addRpcExampleWidget(Widget widget) {
		stackPanel.add(widget, rpcExampleHeader, 4);

	}

	public void addWidgetExampleWidget(Widget widget) {
		stackPanel.add(widget, widgetExampleHeader, 4);

	}

	public HandlerRegistration addSelectionHandler(SelectionHandler<Integer> handler) {
		return stackPanel.addSelectionHandler(handler);
	}

	public void showDisplay(int index) {
		stackPanel.showWidget(index);
	}
}
