package com.parivedasolutions.zaastra.gwt.client.gin;

import net.customware.gwt.presenter.client.DefaultEventBus;
import net.customware.gwt.presenter.client.EventBus;
import net.customware.gwt.presenter.client.gin.AbstractPresenterModule;
import net.customware.gwt.presenter.client.place.ParameterTokenFormatter;
import net.customware.gwt.presenter.client.place.PlaceManager;
import net.customware.gwt.presenter.client.place.TokenFormatter;

import com.google.inject.Singleton;
import com.parivedasolutions.zaastra.gwt.client.AppPresenter;
import com.parivedasolutions.zaastra.gwt.client.AppView;
import com.parivedasolutions.zaastra.gwt.client.GuiDateUtility;
import com.parivedasolutions.zaastra.gwt.client.backbutton.I18nExamplePlace;
import com.parivedasolutions.zaastra.gwt.client.backbutton.RpcExamplePlace;
import com.parivedasolutions.zaastra.gwt.client.backbutton.WidgetExamplePlace;
import com.parivedasolutions.zaastra.gwt.client.backbutton.ZaastraPlaceManager;
import com.parivedasolutions.zaastra.gwt.client.i18n.I18nExamplePresenter;
import com.parivedasolutions.zaastra.gwt.client.i18n.I18nExampleView;
import com.parivedasolutions.zaastra.gwt.client.rpc.RpcExamplePresenter;
import com.parivedasolutions.zaastra.gwt.client.rpc.RpcExampleView;
import com.parivedasolutions.zaastra.gwt.client.rpc.GreetingServiceAsync;
import com.parivedasolutions.zaastra.gwt.client.widget.WidgetExamplePresenter;
import com.parivedasolutions.zaastra.gwt.client.widget.WidgetExampleView;
import com.parivedasolutions.zaastra.gwt.shared.DateUtility;

public class ZaastraClientModule extends AbstractPresenterModule {

	@Override
	protected void configure() {

		bind(EventBus.class).to(DefaultEventBus.class).in(Singleton.class);
		bind(PlaceManager.class).to(ZaastraPlaceManager.class).in(Singleton.class);
		bind(TokenFormatter.class).to(ParameterTokenFormatter.class).in(Singleton.class);
		bind(DateUtility.class).to(GuiDateUtility.class).in(Singleton.class);
		bind(RpcExamplePlace.class).in(Singleton.class);
		bind(I18nExamplePlace.class).in(Singleton.class);
		bind(WidgetExamplePlace.class).in(Singleton.class);
		bind(GreetingServiceAsync.class).in(Singleton.class);
		bind(I18nExampleView.class);

		// Bind Presenters
		bindPresenter(AppPresenter.class, AppPresenter.Display.class, AppView.class);
		bindPresenter(I18nExamplePresenter.class, I18nExamplePresenter.Display.class, I18nExampleView.class);
		bindPresenter(RpcExamplePresenter.class, RpcExamplePresenter.Display.class, RpcExampleView.class);
		bindPresenter(WidgetExamplePresenter.class, WidgetExamplePresenter.Display.class, WidgetExampleView.class);
	}
}
