package com.parivedasolutions.zaastra.gwt.server;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.parivedasolutions.zaastra.gwt.shared.Constants;
import com.parivedasolutions.zaastra.gwt.shared.DateUtility;
import com.parivedasolutions.zaastra.gwt.shared.GwtZaastraException;

public class ServerDateUtility implements DateUtility {

	private static Logger LOG = LoggerFactory.getLogger(ServerDateUtility.class);

	ThreadLocal<DateFormat> dateFormatter = new ThreadLocal<DateFormat>() {
		@Override
		protected DateFormat initialValue() {
			return new SimpleDateFormat(Constants.DATE_FORMAT_PATTERN);
		};
	};

	public String dateToString(Date date) {
		return dateFormatter.get().format(date);
	}

	public Date stringToDate(String dateString) {
		try {
			return dateFormatter.get().parse(dateString);
		} catch (ParseException e) {
			LOG.error("Unable to parse dateString: " + dateString, e);
			throw new GwtZaastraException("Unable to parse dateString: " + dateString, e);
		}
	}

}
