package com.parivedasolutions.zaastra.gwt.server.command;

import java.util.Date;

import com.parivedasolutions.zaastra.gwt.shared.FieldVerifier;
import com.parivedasolutions.zaastra.gwt.shared.HtmlUtils;
import com.parivedasolutions.zaastra.gwt.shared.RpcValueObject;
import com.parivedasolutions.zaastra.gwt.shared.ServiceLocator;

public class GreetingCommand {
	public String getGreeting(String serverInfo, String userAgent, RpcValueObject valueObject) {
		String input = valueObject.getName();
		Date date = valueObject.getDate();

		// Verify that the input is valid.
		if (!FieldVerifier.isValidName(input)) {
			// If the input is not valid, throw an IllegalArgumentException back
			// to the client.
			throw new IllegalArgumentException(FieldVerifier.ERROR_MESSAGE);
		}

		// Escape data from the client to avoid cross-site script
		// vulnerabilities.
		input = HtmlUtils.escapeHtml(input);
		userAgent = HtmlUtils.escapeHtml(userAgent);

		StringBuilder builder = new StringBuilder();
		builder.append("Hello, ");
		builder.append(input);
		if (date != null) {
			builder.append("!<br><br>The Date is: ");
			builder.append(ServiceLocator.getDateUtility().dateToString(date));
		}
		builder.append("<br><br>I am running ");
		builder.append(serverInfo);
		builder.append(".<br><br>It looks like you are using:<br>");
		builder.append(userAgent);
		return builder.toString();
	}
}
