package com.parivedasolutions.zaastra.gwt.shared;

import java.io.Serializable;
import java.util.Date;

@SuppressWarnings("serial")
public class RpcValueObject implements Serializable {

	private String name;
	private Date date;

	/**
	 * no-arg constructor required for GWT serialization
	 */
	@SuppressWarnings("unused")
	private RpcValueObject() {
	}

	public RpcValueObject(String name, Date date) {
		this.name = name;
		this.date = date;
	}

	public String getName() {
		return name;
	}

	public Date getDate() {
		return date;
	}

	@Override
	public boolean equals(Object aThat) {
		if (aThat == null)
			return false;
		if (this == aThat)
			return true;
		if (!(aThat instanceof RpcValueObject))
			return false;
		RpcValueObject that = (RpcValueObject) aThat;

		return doNamesMatch(that) && doDatesMatch(that);
	}

	private boolean doDatesMatch(RpcValueObject that) {
		if (this.getDate() == null && that.getDate() == null)
			return true;
		if (this.getDate() != null && that.getDate() == null)
			return false;
		if (this.getDate() == null && that.getDate() != null)
			return false;
		return getDate().equals(that.getDate());
	}

	private boolean doNamesMatch(RpcValueObject that) {
		if (this.getName() == null && that.getName() == null)
			return true;
		if (this.getName() != null && that.getName() == null)
			return false;
		if (this.getName() == null && that.getName() != null)
			return false;
		return getName().equals(that.getName());
	}

	@Override
	public int hashCode() {
		/**
		 * An initial value for a <code>hashCode</code>, to which is added
		 * contributions from fields. Using a non-zero value decreases collisons
		 * of <code>hashCode</code> values.
		 */
		int SEED = 23;
		if (name == null)
			return SEED + date.hashCode();
		if (date == null)
			return SEED + name.hashCode();
		return SEED + name.hashCode() ^ date.hashCode();
	}

}
