package com.parivedasolutions.zaastra.gwt.shared;

/**
 * Use this Service Locator when you have a utility with different client and
 * server implementations.
 * 
 * Define a common interface, and then inject the Service Locator with the
 * necessary implementation early in application startup.
 */
public class ServiceLocator {

	private static DateUtility dateUtil;

	public static void setDateUtility(DateUtility aDateUtil) {
		dateUtil = aDateUtil;
	}

	public static DateUtility getDateUtility() {
		return dateUtil;
	}

	/**
	 * Reset for unit tests to avoid carryover of static objects
	 */
	public static void reset() {
		dateUtil = null;
	}

}
