package com.parivedasolutions.zaastra.gwt.client;

import java.util.Date;

import com.google.gwt.core.client.GWT;
import com.google.gwt.junit.client.GWTTestCase;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.parivedasolutions.zaastra.gwt.client.rpc.GreetingService;
import com.parivedasolutions.zaastra.gwt.client.rpc.GreetingServiceAsync;
import com.parivedasolutions.zaastra.gwt.shared.RpcValueObject;

/**
 * GWT JUnit <b>integration</b> tests must extend GWTTestCase. Using
 * <code>"*GwtTest"</code> naming pattern exclude them from running with
 * surefire during the test phase.
 */
public class RpcServiceGwtTest extends GWTTestCase {

	private GreetingServiceAsync greetingService;

	/**
	 * Must refer to a valid module that sources this class.
	 */
	@Override
	public String getModuleName() {
		return "com.parivedasolutions.zaastra.gwt.indexJUnit";
	}

	/**
	 * This test will send a request to the server using the greetServer method
	 * in GreetingService and verify the response.
	 */
	public void testGreetingService() {
		// Create the service that we will test.
		greetingService = GWT.create(GreetingService.class);
		ServiceDefTarget target = (ServiceDefTarget) greetingService;
		target.setServiceEntryPoint(GWT.getModuleBaseURL() + "index/greet");

		// Since RPC calls are asynchronous, we will need to wait for a response
		// after this test method returns. This line tells the test runner to
		// wait up to 10 seconds before timing out.
		delayTestFinish(10000);
		Date date = new Date();
		// Send a request to the server.
		greetingService.sendToServer(new RpcValueObject("GWT User", date), new AsyncCallback<String>()
			{
				public void onFailure(Throwable caught) {
					// The request resulted in an unexpected error.
					fail("Request failure: " + caught.getMessage());
				}

				public void onSuccess(String result) {
					// Verify that the response is correct.
					assertTrue(result.startsWith("Hello, GWT User!"));

					// Now that we have received a response, we need to tell the
					// test runner that the test is complete. You must call
					// finishTest() after an asynchronous test finishes
					// successfully, or the test will time out.
					finishTest();
				}
			});
	}
}
