package com.parivedasolutions.zaastra.gwt.server.command;

import static org.junit.Assert.assertTrue;

import java.util.Date;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.parivedasolutions.zaastra.gwt.server.ServerDateUtility;
import com.parivedasolutions.zaastra.gwt.shared.RpcValueObject;
import com.parivedasolutions.zaastra.gwt.shared.ServiceLocator;

public class GreetingCommandTest {

	private GreetingCommand command;

	@Before
	public void setup() {
		ServiceLocator.setDateUtility(new ServerDateUtility());
		command = new GreetingCommand();
	}

	@After
	public void tearDown() {
		ServiceLocator.reset();
	}

	@Test
	public void testCommand() {
		String input = "input";
		Date date = new Date();
		String serverInfo = "serverInfo";
		String userAgent = "Daniel's phone";
		String result = command.getGreeting(serverInfo, userAgent, new RpcValueObject(input, date));
		assertTrue(result.length() > 0);
	}

	@Test
	public void testCommandNullDate() {
		String input = "input";
		Date date = null;
		String serverInfo = "serverInfo";
		String userAgent = "Daniel's phone";
		String result = command.getGreeting(serverInfo, userAgent, new RpcValueObject(input, date));
		assertTrue(result.length() > 0);
	}
}
