package com.parivedasolutions.zaastra.gwt.shared;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class HtmlUtilsTest {
	@Test
	public void escapeAmpersand() {
		String input = "wow && wow &";
		String expected = "wow &amp;&amp; wow &amp;";
		String result = HtmlUtils.escapeHtml(input);
		assertEquals(expected, result);
	}

	@Test
	public void escapeLt() {
		String input = "wow << wow <";
		String expected = "wow &lt;&lt; wow &lt;";
		String result = HtmlUtils.escapeHtml(input);
		assertEquals(expected, result);
	}

	@Test
	public void escapeGt() {
		String input = "wow >> wow >";
		String expected = "wow &gt;&gt; wow &gt;";
		String result = HtmlUtils.escapeHtml(input);
		assertEquals(expected, result);
	}

	@Test
	public void ampersandDoesntEscapeEscapes() {
		String input = "wow &< wow & >";
		String expected = "wow &amp;&lt; wow &amp; &gt;";
		String result = HtmlUtils.escapeHtml(input);
		assertEquals(expected, result);
	}
}
