package com.parivedasolutions.zaastra.gwt.shared;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import org.junit.Test;

public class RpcValueObjectTest {

	private long dateSeed1 = 1308798933000L;
	private long dateSeed2 = 308798933000L;

	@Test
	public void getSets() {
		String expectedName = "name";
		Date expectedDate = new Date();
		RpcValueObject ob1 = new RpcValueObject(expectedName, expectedDate);
		assertEquals(expectedName, ob1.getName());
		assertEquals(expectedDate, ob1.getDate());
	}

	@Test
	public void equalsTests() {
		RpcValueObject ob1 = new RpcValueObject("name", new Date(dateSeed1));
		RpcValueObject ob2 = new RpcValueObject("name", new Date(dateSeed1));
		RpcValueObject ob3 = new RpcValueObject("name", new Date(dateSeed2));
		RpcValueObject ob4 = new RpcValueObject(null, new Date(dateSeed1));
		RpcValueObject ob5 = new RpcValueObject("name", null);

		assertEquals(ob1, ob1);
		assertEquals(ob1, ob2);
		assertNotEquals(ob1, ob3);
		assertNotEquals(ob1, ob4);
		assertNotEquals(ob1, ob5);
		assertNotEquals(ob1, null);
	}

	private void assertNotEquals(RpcValueObject ob, RpcValueObject obo) {
		assertFalse(ob.equals(obo));
	}

	@Test
	public void hashTests() {
		Set<RpcValueObject> set = new HashSet<RpcValueObject>();

		RpcValueObject ob1 = new RpcValueObject("name", new Date(dateSeed1));
		RpcValueObject ob2 = new RpcValueObject("name", new Date(dateSeed1));
		RpcValueObject ob3 = new RpcValueObject("name", new Date(dateSeed2));
		RpcValueObject ob4 = new RpcValueObject(null, new Date(dateSeed1));
		RpcValueObject ob5 = new RpcValueObject("name", null);

		set.add(ob1);
		assertTrue(set.contains(ob1));
		assertTrue(set.contains(ob2));
		assertFalse(set.contains(ob3));
		assertFalse(set.contains(ob4));
		assertFalse(set.contains(ob5));
	}
}
